package cours01;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class TrvAnagramme2 {

	public static void main(String[] args) {

		String[] lexique = null;

		// lecture du lexique
		try {
			BufferedReader br = new BufferedReader(new FileReader(new File("lexique.txt")));
			String ligne;
			int nlig = 0;

			// comptage du nombre de lignes
			while ((ligne = br.readLine()) != null)
				nlig++;
			br.close();
			System.out.println(nlig);

			// lecture des mots du lexique
			lexique = new String[nlig];
			br = new BufferedReader(new FileReader(new File("lexique.txt")));
			for (int i = 0; i < nlig; i++)
				lexique[i] = br.readLine();
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

		// recherche des anagrammes
		for (int i = 0; i < lexique.length; i++) {
			for (int j = i+1; j < lexique.length; j++) {
				for (int k = 0;k < lexique.length;k++) {
				if (anagramme(lexique[i].concat(lexique[j]), lexique[k]) == true)
					System.out.println(lexique[i] + " + " + lexique[j] + " = " + lexique[k]);
				}

			}
		}

	}

	// test anagramme
	public static boolean anagramme(String s1, String s2) {

		if (s1.length() != s2.length())
			return false;

		// recherche des lettres min et max;
		int minL, maxL;
		minL = maxL = s1.charAt(0);
		for (int i = 0; i < s1.length(); i++) {
			if (s1.charAt(i) < minL)
				minL = s1.charAt(i);
			if (s1.charAt(i) > maxL)
				maxL = s1.charAt(i);
		}
		for (int i = 0; i < s2.length(); i++) {
			if (s2.charAt(i) < minL)
				minL = s2.charAt(i);
			if (s2.charAt(i) > maxL)
				maxL = s2.charAt(i);
		}

		// construction du vecteur d'occurences des lettres
		int[] tabOcc = new int[maxL - minL + 1];
		for (int i = 0; i < s1.length(); i++)
			tabOcc[s1.charAt(i) - minL]++; // on ajoute
		for (int i = 0; i < s2.length(); i++)
			tabOcc[s2.charAt(i) - minL]--; // on retranche

		// calcul de la norme du vecteur d'occurences des lettres
		int norme = 0;
		for (int i = 0; i < tabOcc.length; i++)
			norme += Math.abs(tabOcc[i]);
		if (norme == 0)
			return true;
		else
			return false;

	}

}
